SHEBANG
# Copyright @BABOLO (C)2002,2003
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up-anon.m4,v 1.1 2003/05/03 04:06:19 babolo Exp $

JNTROSTUP(ftpd,-anon,ftpddnl
,dnl
# jailup ${inclass}${suffix} dir jailname jailaddr [user [group [port]]]
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dir relative to ${JAILUPDIR} and ${JAILRODIR}
# system /usr/libexec/ftpd
#                                                   useddnl
)

TEMPLATE=${this}/template${suffix}
jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
user="${4:-root}"
group="${5:-ftp}"
port="${6:-21}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}
ETCOPY(host.conf hosts protocols resolv.conf)
${up_shlib} "${main_dir}/usr/lib" << "EOF"
    skey md crypt util m pam c wrap
EOF

${up_libexe} "${main_dir}/usr/libexec" << EOF
    ld-elf.so.1
    ftpd
    xinetd
EOF

${touch} "${main_dir}/var/log/ftpd"

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
cf="xinetd"; if  [ -e "${conf_dir}/${cf}" ]; then cf="${cf}.sample"; fi
${sed} -e "s|%%PORT%%|${port}|"\
       -e "s|%%GROUP%%|${group}|"\
       -e "s|%%USER%%|${user}|" "${TEMPLATE}" > "${conf_dir}/${cf}"

if  [ ! -e "${conf_dir}/group" ]; then
    ${cat} << "EOF" > "${conf_dir}/group"
wheel:*:0:
ftp:*:14:
nogroup:*:65533:
nobody:*:65534:
EOF
fi

if  [ ! -e "${conf_dir}/master.template" ]; then
    ${cat} << "EOF" > "${conf_dir}/master.template"
root:*:0:0::0:0:Charlie &:/:/nonexistent
ftp:*:14:14::0:0:Anonymous FTP Admin:/var/ftp:/nonexistent
nobody:*:65534:65534::0:0:Unprivileged user:/nonexistent:/nonexistent
EOF
fi

if  [ ! -e "${conf_dir}/master.passwd" ]; then
    ${cp} -p "${conf_dir}/master.template" "${conf_dir}/master.passwd"
fi
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.			type=dir mode=0755
    group
    host.conf
    hosts
    localtime
    protocols
    resolv.conf
    master.passwd		mode=0600
    xinetd
..
EOF
${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"

${cat} << EOF >> "${genconfig}"
#${genclass}	xinetd	${jdir}	${jailsname}	${jailsaddr}	0	0	0	xinetd
EOF

      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${cat} << EOF >> "${etcdir}/fstab"
#/null			${main_dir}/dev	null	ro,noexec	0 0
#${conf_dir}		${main_dir}/etc	null	ro,nodev,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
